// Generated by gencpp from file ld_msgs/ld_object.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_OBJECT_H
#define LD_MSGS_MESSAGE_LD_OBJECT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <std_msgs/ColorRGBA.h>
#include <geometry_msgs/Pose.h>
#include <geometry_msgs/Point.h>
#include <geometry_msgs/Pose.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Point.h>
#include <geometry_msgs/Twist.h>
#include <geometry_msgs/Twist.h>
#include <geometry_msgs/Twist.h>
#include <geometry_msgs/Twist.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_object_
{
  typedef ld_object_<ContainerAllocator> Type;

  ld_object_()
    : header()
    , id(0)
    , object_status()
    , confidence(0.0)
    , color()
    , pose_reliable(false)
    , box_label(0)
    , pose()
    , pose_var()
    , jsk_pose()
    , yaw(0.0)
    , yaw_var(0.0)
    , dimensions()
    , dimensions_var()
    , velocity()
    , velocity_var()
    , acceleration()
    , acceleration_var()
    , class_label_true()
    , class_label_pred()
    , target_added(false)
    , target_deleted(false)
    , behavior_state(0)  {
    }
  ld_object_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , id(0)
    , object_status(_alloc)
    , confidence(0.0)
    , color(_alloc)
    , pose_reliable(false)
    , box_label(0)
    , pose(_alloc)
    , pose_var(_alloc)
    , jsk_pose(_alloc)
    , yaw(0.0)
    , yaw_var(0.0)
    , dimensions(_alloc)
    , dimensions_var(_alloc)
    , velocity(_alloc)
    , velocity_var(_alloc)
    , acceleration(_alloc)
    , acceleration_var(_alloc)
    , class_label_true(_alloc)
    , class_label_pred(_alloc)
    , target_added(false)
    , target_deleted(false)
    , behavior_state(0)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef uint32_t _id_type;
  _id_type id;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _object_status_type;
  _object_status_type object_status;

   typedef float _confidence_type;
  _confidence_type confidence;

   typedef  ::std_msgs::ColorRGBA_<ContainerAllocator>  _color_type;
  _color_type color;

   typedef uint8_t _pose_reliable_type;
  _pose_reliable_type pose_reliable;

   typedef uint8_t _box_label_type;
  _box_label_type box_label;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _pose_type;
  _pose_type pose;

   typedef  ::geometry_msgs::Point_<ContainerAllocator>  _pose_var_type;
  _pose_var_type pose_var;

   typedef  ::geometry_msgs::Pose_<ContainerAllocator>  _jsk_pose_type;
  _jsk_pose_type jsk_pose;

   typedef float _yaw_type;
  _yaw_type yaw;

   typedef float _yaw_var_type;
  _yaw_var_type yaw_var;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _dimensions_type;
  _dimensions_type dimensions;

   typedef  ::geometry_msgs::Point_<ContainerAllocator>  _dimensions_var_type;
  _dimensions_var_type dimensions_var;

   typedef  ::geometry_msgs::Twist_<ContainerAllocator>  _velocity_type;
  _velocity_type velocity;

   typedef  ::geometry_msgs::Twist_<ContainerAllocator>  _velocity_var_type;
  _velocity_var_type velocity_var;

   typedef  ::geometry_msgs::Twist_<ContainerAllocator>  _acceleration_type;
  _acceleration_type acceleration;

   typedef  ::geometry_msgs::Twist_<ContainerAllocator>  _acceleration_var_type;
  _acceleration_var_type acceleration_var;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _class_label_true_type;
  _class_label_true_type class_label_true;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _class_label_pred_type;
  _class_label_pred_type class_label_pred;

   typedef uint8_t _target_added_type;
  _target_added_type target_added;

   typedef uint8_t _target_deleted_type;
  _target_deleted_type target_deleted;

   typedef uint8_t _behavior_state_type;
  _behavior_state_type behavior_state;





  typedef boost::shared_ptr< ::ld_msgs::ld_object_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_object_<ContainerAllocator> const> ConstPtr;

}; // struct ld_object_

typedef ::ld_msgs::ld_object_<std::allocator<void> > ld_object;

typedef boost::shared_ptr< ::ld_msgs::ld_object > ld_objectPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_object const> ld_objectConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_object_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_object_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/shawn/Documents/ROS_ws/src/HighResolutionLidarAlgorithm/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_object_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_object_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_object_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_object_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_object_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_object_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_object_<ContainerAllocator> >
{
  static const char* value()
  {
    return "84fa7a180caef7c1f3dd258e8122f7ea";
  }

  static const char* value(const ::ld_msgs::ld_object_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x84fa7a180caef7c1ULL;
  static const uint64_t static_value2 = 0xf3dd258e8122f7eaULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_object_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_object";
  }

  static const char* value(const ::ld_msgs::ld_object_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_object_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Header                 header\n\
################ object character\n\
uint32                          id  # ukf_id\n\
string                          object_status # dynamic or static status of the object\n\
float32                         confidence   # Overall detected confidence of the object\n\
std_msgs/ColorRGBA              color   # Define this object specific color\n\
\n\
################ 3D BB\n\
bool                            pose_reliable\n\
uint8                           box_label  # Null = 0, on_road = 1, on_edge = 2, edge_left = 3, edge_right = 4\n\
\n\
geometry_msgs/Pose              pose\n\
geometry_msgs/Point             pose_var \n\
\n\
geometry_msgs/Pose              jsk_pose # pose from accociated bbox\n\
\n\
float32                         yaw # yaw angel in radian\n\
float32                         yaw_var # cov of yaw angel in radian\n\
\n\
geometry_msgs/Vector3           dimensions\n\
geometry_msgs/Point             dimensions_var  \n\
\n\
geometry_msgs/Twist             velocity\n\
geometry_msgs/Twist             velocity_var\n\
\n\
geometry_msgs/Twist             acceleration\n\
geometry_msgs/Twist             acceleration_var\n\
\n\
#################  class label info\n\
string                          class_label_true # ground truth labels\n\
string                          class_label_pred # predicted class labels\n\
bool                            target_added # manually added target by labeling tool\n\
bool                            target_deleted # manually deleted target by labeling tool\n\
\n\
############### Behavior State of the Detected Object\n\
uint8                           behavior_state # FORWARD_STATE = 0, STOPPING_STATE = 1, BRANCH_LEFT_STATE = 2, BRANCH_RIGHT_STATE = 3, YIELDING_STATE = 4, ACCELERATING_STATE = 5, SLOWDOWN_STATE = 6\n\
\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: std_msgs/ColorRGBA\n\
float32 r\n\
float32 g\n\
float32 b\n\
float32 a\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of position and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
# It is only meant to represent a direction. Therefore, it does not\n\
# make sense to apply a translation to it (e.g., when applying a \n\
# generic rigid transformation to a Vector3, tf2 will only apply the\n\
# rotation). If you want your data to be translatable too, use the\n\
# geometry_msgs/Point message instead.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Twist\n\
# This expresses velocity in free space broken into its linear and angular parts.\n\
Vector3  linear\n\
Vector3  angular\n\
";
  }

  static const char* value(const ::ld_msgs::ld_object_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_object_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.id);
      stream.next(m.object_status);
      stream.next(m.confidence);
      stream.next(m.color);
      stream.next(m.pose_reliable);
      stream.next(m.box_label);
      stream.next(m.pose);
      stream.next(m.pose_var);
      stream.next(m.jsk_pose);
      stream.next(m.yaw);
      stream.next(m.yaw_var);
      stream.next(m.dimensions);
      stream.next(m.dimensions_var);
      stream.next(m.velocity);
      stream.next(m.velocity_var);
      stream.next(m.acceleration);
      stream.next(m.acceleration_var);
      stream.next(m.class_label_true);
      stream.next(m.class_label_pred);
      stream.next(m.target_added);
      stream.next(m.target_deleted);
      stream.next(m.behavior_state);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_object_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_object_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_object_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "id: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.id);
    s << indent << "object_status: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.object_status);
    s << indent << "confidence: ";
    Printer<float>::stream(s, indent + "  ", v.confidence);
    s << indent << "color: ";
    s << std::endl;
    Printer< ::std_msgs::ColorRGBA_<ContainerAllocator> >::stream(s, indent + "  ", v.color);
    s << indent << "pose_reliable: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.pose_reliable);
    s << indent << "box_label: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.box_label);
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
    s << indent << "pose_var: ";
    s << std::endl;
    Printer< ::geometry_msgs::Point_<ContainerAllocator> >::stream(s, indent + "  ", v.pose_var);
    s << indent << "jsk_pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "  ", v.jsk_pose);
    s << indent << "yaw: ";
    Printer<float>::stream(s, indent + "  ", v.yaw);
    s << indent << "yaw_var: ";
    Printer<float>::stream(s, indent + "  ", v.yaw_var);
    s << indent << "dimensions: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.dimensions);
    s << indent << "dimensions_var: ";
    s << std::endl;
    Printer< ::geometry_msgs::Point_<ContainerAllocator> >::stream(s, indent + "  ", v.dimensions_var);
    s << indent << "velocity: ";
    s << std::endl;
    Printer< ::geometry_msgs::Twist_<ContainerAllocator> >::stream(s, indent + "  ", v.velocity);
    s << indent << "velocity_var: ";
    s << std::endl;
    Printer< ::geometry_msgs::Twist_<ContainerAllocator> >::stream(s, indent + "  ", v.velocity_var);
    s << indent << "acceleration: ";
    s << std::endl;
    Printer< ::geometry_msgs::Twist_<ContainerAllocator> >::stream(s, indent + "  ", v.acceleration);
    s << indent << "acceleration_var: ";
    s << std::endl;
    Printer< ::geometry_msgs::Twist_<ContainerAllocator> >::stream(s, indent + "  ", v.acceleration_var);
    s << indent << "class_label_true: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.class_label_true);
    s << indent << "class_label_pred: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.class_label_pred);
    s << indent << "target_added: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.target_added);
    s << indent << "target_deleted: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.target_deleted);
    s << indent << "behavior_state: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.behavior_state);
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_OBJECT_H
